package xyz.lychee.lagfixer.libs.adventure.text.serializer;

import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface ComponentEncoder<I extends Component, R> {
   @NotNull R serialize(final @NotNull I component);

   @Contract(
      value = "!null -> !null; null -> null",
      pure = true
   )
   default @Nullable R serializeOrNull(final @Nullable I component) {
      return this.serializeOr(component, (Object)null);
   }

   @Contract(
      value = "!null, _ -> !null; null, _ -> param2",
      pure = true
   )
   default @Nullable R serializeOr(final @Nullable I component, final @Nullable R fallback) {
      return component == null ? fallback : this.serialize(component);
   }
}
